package com.diaoyun.zion.chinafrica.service.impl;

import com.diaoyun.zion.chinafrica.dao.TbCfItemDetailDao;
import com.diaoyun.zion.chinafrica.entity.TbCfItemDetailEntity;
import com.diaoyun.zion.chinafrica.service.TbCfItemDetailService;
import com.diaoyun.zion.master.util.IdUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * 商品详情Service实现类
 *
 * @author lipengjun
 * @date 2019-08-16 15:51:16
 */
@Service("tbCfItemDetailService")
public class TbCfItemDetailServiceImpl implements TbCfItemDetailService {
    @Autowired
    private TbCfItemDetailDao tbCfItemDetailDao;

    @Override
    public TbCfItemDetailEntity queryObject(String itemId) {
        return tbCfItemDetailDao.queryObject(itemId);
    }

    @Override
    public List<TbCfItemDetailEntity> queryList(Map<String, Object> map) {
        return tbCfItemDetailDao.queryList(map);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        return tbCfItemDetailDao.queryTotal(map);
    }

    @Override
    public int save(TbCfItemDetailEntity tbCfItemDetail) {
        tbCfItemDetail.setItemId(IdUtil.createIdbyUUID());
        return tbCfItemDetailDao.save(tbCfItemDetail);
    }

    @Override
    public int update(TbCfItemDetailEntity tbCfItemDetail) {
        return tbCfItemDetailDao.update(tbCfItemDetail);
    }

    @Override
    public int delete(String itemId) {
        return tbCfItemDetailDao.delete(itemId);
    }

    @Override
    public int deleteBatch(String[] itemIds) {
        return tbCfItemDetailDao.deleteBatch(itemIds);
    }
}
