package com.diaoyun.zion.master.util;

import org.jsoup.Jsoup;
import org.jsoup.nodes.DataNode;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import java.util.HashMap;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class JsoupUtil {
    public static String unknow="未知";
    //获取淘宝访问商品详情页时，返回的sibUrl
    public static String getSibUrl(String content) {
        String usableSibUrl=null;
        Document document = Jsoup.parse(content);
        Elements elementList=document.getElementsByTag("script");
        for(Element element:elementList) {
            for(DataNode dataNode:element.dataNodes()) {
                String dataStr=dataNode.getWholeData();
                //获取带有 g_config 变量的 script 标签
                Pattern p = Pattern.compile("(var){1,1}\\s+(g_config){1,1}\\s+={1,1}[\\s\\S]*(;){1,1}"); //  Regex for the value of the key
                Matcher m = p.matcher(dataStr); // you have to use html here and NOT text! Text will drop the 'key' part
                while ((m.find())) {
                    //System.out.println(m.group());
                    String configGroup=m.group();
                    String varArr[]=configGroup.split(";");
                    for(String variable:varArr) {
                        //获取g_config 变量
                        Pattern variablePattern = Pattern.compile("(var){1,1}\\s+(g_config){1,1}\\s+={1,1}[\\s\\S]*"); //  Regex for the value of the key
                        Matcher varMatcher = variablePattern.matcher(variable);
                        while (varMatcher.find()) {
                            //获取 sibUrl 属性
                            Pattern sibUrlPattern = Pattern.compile("((sibUrl){1,1}?)\\s+(:{1,1}?)[\\s]*(('){1,1}?)[\\S]*(('){1,1}?)"); //  Regex for the value of the key
                            String configStr=varMatcher.group();
                            Matcher sibUrlMatcher = sibUrlPattern.matcher(configStr);
                            while (sibUrlMatcher.find()) {
                                int urlBegin=sibUrlMatcher.group().indexOf("'");
                                int urlEnd=sibUrlMatcher.group().lastIndexOf("'");
                                String unUseSibUrl=sibUrlMatcher.group().substring(urlBegin+1,urlEnd);
                                usableSibUrl="https:"+unUseSibUrl;

                            }
                        }
                    }
                    break;
                }

            }
        }
        return usableSibUrl;
    }

    /**
     * 解析出商品详情
     * @param content
     * @return
     */
    public static Map<String, Object> getPropMap(String content) {
        Map<String, Object> resultMap=new HashMap<>();
        Document document = Jsoup.parse(content);
        Element skuElement=document.getElementById("J_isku");
        Elements propList=skuElement.getElementsByClass("J_Prop");
        if(propList==null||propList.size()<1) {
            resultMap.put("hasSku",false);
        } else {
            getSku(propList,resultMap);
        }
        return resultMap;
    }

    /**
     * 获取sku 对照着返回html来写方法
     * @param propList
     * @param resultMap
     */
    private static void getSku(Elements propList, Map<String, Object> resultMap) {
        for(Element element:propList) {
            //属性描述
            Elements propNameELements=element.getElementsByClass("tb-property-type");
            String propName=JsoupUtil.unknow;
            if(propNameELements!=null&&propNameELements.size()>0) {
                propName=propNameELements.get(0).text();
            }

            if(resultMap.get(propName)==null) {
                //防止属性名重复
            } else {
                int random= (int) (Math.random()*1000);
                propName=propName+random;
            }
            Map <String,Object> skuMap=new HashMap<>();
            resultMap.put(propName,skuMap);

            Elements liList= element.getElementsByTag("li");
            if(liList!=null&&liList.size()>0) {
                for(Element liEle:liList) {
                    String propKey=liEle.attr("data-value");
                    Elements spanList=liEle.getElementsByTag("span");
                    Elements aList=liEle.getElementsByTag("a");
                    String title=JsoupUtil.unknow;
                    String image="";
                    if(liList!=null&&liList.size()>0) {
                        title=spanList.get(0).text();
                    }
                    if(liList!=null&&liList.size()>0) {
                        image=aList.get(0).attr("style");
                    }
                    Map <String,Object> propMap=new HashMap<>();
                    propMap.put("title",title);
                    propMap.put("image",image);
                    ((Map <String,Object>)resultMap.get(propName)).put(propKey,propMap);
                }
            }
        }
    }
}
