package com.diaoyun.zion;

import com.diaoyun.zion.master.bo.TecentTranslateParam;
import com.diaoyun.zion.master.thread.TaskLimitSemaphore;
import com.diaoyun.zion.master.thread.TranslateCallable;
import com.diaoyun.zion.master.util.*;
import freemarker.template.Configuration;
import net.sf.json.JSONObject;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.text.StringEscapeUtils;
import org.apache.http.*;
import org.apache.http.client.CookieStore;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.client.methods.RequestBuilder;
import org.apache.http.client.protocol.HttpClientContext;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.impl.client.*;
import org.apache.http.message.BasicHeader;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.io.*;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.*;
import java.util.concurrent.*;

@RunWith(SpringRunner.class)
@SpringBootTest
public class ZionApplicationTests {

    @Autowired
    private Configuration config;

    private TaskLimitSemaphore taskLimitSemaphore=new TaskLimitSemaphore(12);

    private List<Map<String, Object>> futureList= new ArrayList<Map<String, Object>>();

    @Test
    public void contextLoads() throws InterruptedException, URISyntaxException, IOException, ExecutionException {
        /*Template t = config.getTemplate("email-template.ftl");
        Map<String,String> model=new HashMap<>();
        model.put("Name","yonghuming");
        model.put("location","zhongguo");
        String html = FreeMarkerTemplateUtils.processTemplateIntoString(t, model);
        HtmlEmail email=new HtmlEmail();//创建一个HtmlEmail实例对象
        email.setHostName("smtp.yeah.net");//邮箱的SMTP服务器，一般123邮箱的是smtp.123.com,qq邮箱为smtp.qq.com
        email.setCharset("utf-8");//设置发送的字符类型
        email.addTo("zhengfanguang@163.com");//设置收件人
        email.setFrom("chinafrica@yeah.net","chinafrica");//发送人的邮箱为自己的，用户名可以随便填
        email.setAuthentication("chinafrica@yeah.net","diaoyun2019");//设置发送人的邮箱和用户名和授权码(授权码是自己设置的)
        email.setSubject("测试22");//设置发送主题
        email.setMsg(html);//设置发送内容
        email.send();//进行发送*/
        /*List<Map<String,Object>> returnList=new ArrayList<>();
        String s=JSONUtils.toJSONString(returnList);
        System.out.println(s);*/
        /*test copyProperties*/

        /*TbCfUserInfoVo tbCfUserInfoVo = new TbCfUserInfoVo();
        TbCfUserInfoEntity tbCfUserInfoEntity =new TbCfUserInfoEntity();
        tbCfUserInfoVo.setAccount("11111");
        BeanUtils.copyProperties(tbCfUserInfoVo,tbCfUserInfoEntity);
        System.out.println(JSON.toJSONString(tbCfUserInfoEntity));*/
        /*test copyProperties*/
        /*String password=PasswordProvider.encrypt("123456");
        System.out.println("password:"+password);
        String password2=PasswordProvider.encrypt(password);
        System.out.println("password2:"+password2);*/


        /*String url="http://dev.diaosaas.com/zion/chinafrica/order";
        HttpClient client = HttpClientBuilder.create().build();//构建一个Client
        Map<String,String> paramMap=new HashMap<>();
        paramMap.put("beginTime","1564548584");
        paramMap.put("endTime","1564558584");
        List<NameValuePair> formparams = setHttpParams(paramMap);
        String param = URLEncodedUtils.format(formparams, "UTF-8");
        HttpGet httpGet = new HttpGet();    //构建一个GET请求
        httpGet.setURI(URI.create(url + "?" + param));
        HttpResponse response = client.execute(httpGet);//提交GET请求
        HttpEntity result = response.getEntity();//拿到返回的HttpResponse的"实体"
        String content = EntityUtils.toString(result);
        JSONArray res = JSONArray.fromObject(content);//把信息封装为jsonarray
        System.out.println(res);*/


        /*爬取淘宝数据*/
        String url="https://item.taobao.com/item.htm?spm=a230r.1.14.21.22543186dllgZW&id=538082050316&ns=1&abbucket=18#detail";
        URI uri=new URIBuilder(url).build();

        //创建一个HttpContext对象，用来保存Cookie
        //HttpClientContext httpClientContext = HttpClientContext.create();


        //构造自定义的HttpClient对象
        CloseableHttpClient httpClient = HttpClientUtil.createBrowserClient();

        //构造请求对象
        HttpUriRequest httpUriRequest = RequestBuilder.get().setUri(uri).build();

        /*****************获取商品详情链接********************/
        //执行请求，传入HttpContext，将会得到请求结果的信息
        HttpResponse httpResponse=httpClient.execute(httpUriRequest);
        HttpEntity result = httpResponse.getEntity();//拿到返回的HttpResponse的"实体"
        String content = EntityUtils.toString(result);
        //获取商品详情url
        String usableSibUrl= JsoupUtil.getSibUrl(content);
        //解析商品sku信息
        Map<String,Object> propMap=JsoupUtil.getPropMap(content);
        //httpClient.close();
        System.out.println("时间："+System.currentTimeMillis());
        //翻译
        translateProp(propMap);
        for(Map<String,Object> futureMap:futureList) {

            Future<Map<String,Object>> future= (Future<Map<String, Object>>) futureMap.get("future");
            Map<String,Object> valeMap = (Map<String,Object> ) futureMap.get("value");
            while(!future.isDone());//Future返回如果没有完成，则一直循环等待，直到Future返回完成
            System.out.println("翻译完成！！！");
            Map<String,Object> resultMap=future.get();
            String targetText="unknow";
            if(resultMap!=null&&(int)resultMap.get("ret")==0) {
                Map<String,Object> dataMap=(Map<String,Object>)resultMap.get("data");
                targetText= (String) dataMap.get("target_text");
                valeMap.put("translate",targetText);
            } else {
                System.out.println("翻译出错");
            }
        }
        //关闭线程池
        taskLimitSemaphore.shutdown();
        System.out.println("时间："+System.currentTimeMillis());
        /*****************获取商品详情********************/
        //删除需要登录的模块
        usableSibUrl=deleteLoginModule(usableSibUrl);
        URI sibUri=new URIBuilder(usableSibUrl).build();
        //构造请求对象
        HttpUriRequest sibUriRequest = RequestBuilder.get().setUri(sibUri).build();
        BasicHeader basicHeader=new BasicHeader("referer", url);
        //构造自定义的HttpClient对象
        CloseableHttpClient sibClient = HttpClientUtil.createBrowserClient(basicHeader);
        //创建一个HttpContext对象，用来保存Cookie
        //HttpClientContext sibClientContext = HttpClientContext.create();
        //执行请求，传入HttpContext，将会得到请求结果的信息
        HttpResponse sibResponse=sibClient.execute(sibUriRequest);
        HttpEntity sibResult = sibResponse.getEntity();//拿到返回的HttpResponse的"实体"
        String sibContent = EntityUtils.toString(sibResult);
        //unicode 解码
        sibContent=StringEscapeUtils.unescapeJava(sibContent);
        Map sibMap=JSONObject.fromObject(sibContent);
        sibMap.put("Jprop",propMap);
        System.out.println(JSONObject.fromObject(propMap));
        //从请求结果中获取Cookie，此时的Cookie已经带有登录信息了
        //CookieStore store = httpClientContext.getCookieStore();
        sibClient.close();

        ///////////////////////*获取淘宝数据 END*//////////////


    }

    private void translateProp(Map<String, Object> propMap) throws ExecutionException, InterruptedException {
        /*腾讯翻译*/

        for(Map.Entry<String,Object>entry : propMap.entrySet()) {
            String key=entry.getKey();
            Map <String,Object> value= (Map<String, Object>) entry.getValue();
            //翻译属性名
            if(ValidateUtils.isChinese(key)) {
                translateText(value,key);
                //value.put("translate",translate);
            }
            //翻译sku title
            if(value!=null&&value.size()>0) {
                translateTitle(value);
            }

        }



    }

    private void translateTitle(Map<String, Object> skuMap) throws ExecutionException, InterruptedException {
        for(Map.Entry<String,Object>entry : skuMap.entrySet()) {
            String key=entry.getKey();
            if(entry.getValue() instanceof Map) {
                Map<String, Object> value = (Map<String, Object>) entry.getValue();
                String title = (String) value.get("title");
                if (StringUtils.isNotBlank(title)) {
                    //翻译属性名
                    if (ValidateUtils.isContainChinese(title)) {
                        translateText(value,title);
                        //value.put("translate", translate);
                    }
                }
            }
        }
    }

    private void translateText(Map<String,Object> valeMap,String text) throws ExecutionException, InterruptedException {
        TecentTranslateParam tecentTranslateParam=new TecentTranslateParam(text);
        Future<Map<String,Object>> future = null;
        try {
            future = taskLimitSemaphore.submit(new TranslateCallable(tecentTranslateParam));
            Map<String,Object> map=new HashMap<>();
            map.put("future",future);
            map.put("value",valeMap);
            futureList.add(map);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 去除需要登录或者不需要返回的参数
     * @param usableSibUrl
     * @return
     */
    private String deleteLoginModule(String usableSibUrl) {
        usableSibUrl=usableSibUrl.replaceAll("couponActivity","");
        usableSibUrl=usableSibUrl.replaceAll("soldQuantity","");
        usableSibUrl=usableSibUrl.replaceAll("tradeContract","");
        usableSibUrl=usableSibUrl.replaceAll("upp","");
        //TOOD 运费格式有问题，暂去除
        usableSibUrl=usableSibUrl.replaceAll("deliveryFee","");
        usableSibUrl=usableSibUrl.replaceAll("delivery","");
        return usableSibUrl;
    }

    //使用序列化的方式保存CookieStore到本地文件，方便后续的读取使用
    private static void saveCookieStore( CookieStore cookieStore, String savePath ) throws IOException {

        FileOutputStream fs = new FileOutputStream(savePath);
        ObjectOutputStream os =  new ObjectOutputStream(fs);
        os.writeObject(cookieStore);
        os.close();

    }

    //读取Cookie的序列化文件，读取后可以直接使用
    private static CookieStore readCookieStore( String savePath ) throws IOException, ClassNotFoundException {

        FileInputStream fs = new FileInputStream(savePath);//("foo.ser");
        ObjectInputStream ois = new ObjectInputStream(fs);
        CookieStore cookieStore = (CookieStore) ois.readObject();
        ois.close();
        return cookieStore;


    }

    private List<NameValuePair> setHttpParams(Map<String, Object> paramsMap) {
        List<NameValuePair> list = new ArrayList<NameValuePair>();
        for (String key : paramsMap.keySet()) {
            list.add(new BasicNameValuePair(key, String.valueOf(paramsMap.get(key))));
        }
        return list;
    }






}


class TaskWithResult implements Callable<String> {
    private int id;

    public TaskWithResult(int id){
        this.id = id;
    }

    /**
     * 任务的具体过程，一旦任务传给ExecutorService的submit方法，
     * 则该方法自动在一个线程上执行
     */
    public String call() throws Exception {
        System.out.println("call()方法被自动调用！！！    " + Thread.currentThread().getName());
        //该返回结果将被Future的get方法得到
        return "call()方法被自动调用，任务返回的结果是：" + id + "    " + Thread.currentThread().getName();
    }
}